/**
 * <copyright>
 * </copyright>
 *
 * $Id: ReferencedXMACompositeImpl.java 8635 2011-11-03 21:04:39Z hoenninger $
 */
package org.openxma.dsl.pom.model.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.openxma.dsl.pom.PomPackage;
import org.openxma.dsl.pom.model.ComplexElement;
import org.openxma.dsl.pom.model.ComposedElement;
import org.openxma.dsl.pom.model.Composite;
import org.openxma.dsl.pom.model.Content;
import org.openxma.dsl.pom.model.FieldFlag;
import org.openxma.dsl.pom.model.GuiElement;
import org.openxma.dsl.pom.model.IComposite;
import org.openxma.dsl.pom.model.IElementOnWhichCanBeAttached;
import org.openxma.dsl.pom.model.Page;
import org.openxma.dsl.pom.model.ReferencedXMAComposite;
import org.openxma.dsl.pom.model.TabableFlag;
import org.openxma.dsl.pom.model.ReferencedXMAPage;

import at.spardat.xma.guidesign.XMAComposite;
import at.spardat.xma.guidesign.XMAPage;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Referenced XMA Composite</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMACompositeImpl#getContent <em>Content</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMACompositeImpl#getXmaComposite <em>Xma Composite</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMACompositeImpl#getFieldFlags <em>Field Flags</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMACompositeImpl#getTabableFlag <em>Tabable Flag</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMACompositeImpl#isReferencingPageComposite <em>Referencing Page Composite</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMACompositeImpl#isHorizontalPartitioning <em>Horizontal Partitioning</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMACompositeImpl#isVerticalPartitioning <em>Vertical Partitioning</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ReferencedXMACompositeImpl extends ReferencedXMAGuiElementImpl implements ReferencedXMAComposite {
	/**
	 * The cached value of the '{@link #getContent() <em>Content</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContent()
	 * @generated
	 * @ordered
	 */
	protected Content content;

	/**
	 * The cached value of the '{@link #getXmaComposite() <em>Xma Composite</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getXmaComposite()
	 * @generated
	 * @ordered
	 */
	protected XMAComposite xmaComposite;

	/**
	 * The cached value of the '{@link #getFieldFlags() <em>Field Flags</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFieldFlags()
	 * @generated
	 * @ordered
	 */
	protected EList<FieldFlag> fieldFlags;

	/**
	 * The cached value of the '{@link #getTabableFlag() <em>Tabable Flag</em>}' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getTabableFlag()
	 * @generated
	 * @ordered
	 */
    protected TabableFlag tabableFlag;

    /**
	 * The default value of the '{@link #isReferencingPageComposite() <em>Referencing Page Composite</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isReferencingPageComposite()
	 * @generated
	 * @ordered
	 */
	protected static final boolean REFERENCING_PAGE_COMPOSITE_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isReferencingPageComposite() <em>Referencing Page Composite</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isReferencingPageComposite()
	 * @generated
	 * @ordered
	 */
	protected boolean referencingPageComposite = REFERENCING_PAGE_COMPOSITE_EDEFAULT;

	/**
	 * The default value of the '{@link #isHorizontalPartitioning() <em>Horizontal Partitioning</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isHorizontalPartitioning()
	 * @generated
	 * @ordered
	 */
	protected static final boolean HORIZONTAL_PARTITIONING_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isHorizontalPartitioning() <em>Horizontal Partitioning</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isHorizontalPartitioning()
	 * @generated
	 * @ordered
	 */
	protected boolean horizontalPartitioning = HORIZONTAL_PARTITIONING_EDEFAULT;

	/**
	 * The default value of the '{@link #isVerticalPartitioning() <em>Vertical Partitioning</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isVerticalPartitioning()
	 * @generated
	 * @ordered
	 */
	protected static final boolean VERTICAL_PARTITIONING_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isVerticalPartitioning() <em>Vertical Partitioning</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isVerticalPartitioning()
	 * @generated
	 * @ordered
	 */
	protected boolean verticalPartitioning = VERTICAL_PARTITIONING_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReferencedXMACompositeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PomPackage.Literals.REFERENCED_XMA_COMPOSITE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Content getContent() {
		return content;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetContent(Content newContent, NotificationChain msgs) {
		Content oldContent = content;
		content = newContent;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_COMPOSITE__CONTENT, oldContent, newContent);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setContent(Content newContent) {
		if (newContent != content) {
			NotificationChain msgs = null;
			if (content != null)
				msgs = ((InternalEObject)content).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_COMPOSITE__CONTENT, null, msgs);
			if (newContent != null)
				msgs = ((InternalEObject)newContent).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_COMPOSITE__CONTENT, null, msgs);
			msgs = basicSetContent(newContent, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_COMPOSITE__CONTENT, newContent, newContent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isReferencingPageComposite() {
		return referencingPageComposite;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setReferencingPageComposite(boolean newReferencingPageComposite) {
		boolean oldReferencingPageComposite = referencingPageComposite;
		referencingPageComposite = newReferencingPageComposite;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_COMPOSITE__REFERENCING_PAGE_COMPOSITE, oldReferencingPageComposite, referencingPageComposite));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isVerticalPartitioning() {
		return verticalPartitioning;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setVerticalPartitioning(boolean newVerticalPartitioning) {
		boolean oldVerticalPartitioning = verticalPartitioning;
		verticalPartitioning = newVerticalPartitioning;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_COMPOSITE__VERTICAL_PARTITIONING, oldVerticalPartitioning, verticalPartitioning));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isHorizontalPartitioning() {
		return horizontalPartitioning;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setHorizontalPartitioning(boolean newHorizontalPartitioning) {
		boolean oldHorizontalPartitioning = horizontalPartitioning;
		horizontalPartitioning = newHorizontalPartitioning;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_COMPOSITE__HORIZONTAL_PARTITIONING, oldHorizontalPartitioning, horizontalPartitioning));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @modified
	 */
	public XMAComposite getXmaComposite() {	
		// Implicit referencing a XMAComposite
		if (xmaComposite == null && isReferencingPageComposite()) {
			Content cont = (Content)eContainer();
			Page page = (Page)cont.eContainer();
			if (page instanceof ReferencedXMAPage) {
				ReferencedXMAPage refP = (ReferencedXMAPage)page;
				XMAPage xmaP = refP.getXmaPage();
				if (xmaP != null) {
					xmaComposite = xmaP.getComposite();
				}
			}
		// Explicit referencing a XMAComposite			
		} else if (xmaComposite != null && xmaComposite.eIsProxy()) {  				
			InternalEObject oldXmaComposite = (InternalEObject)xmaComposite;
			xmaComposite = (XMAComposite)eResolveProxy(oldXmaComposite);
			if (xmaComposite != oldXmaComposite) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, PomPackage.REFERENCED_XMA_COMPOSITE__XMA_COMPOSITE, oldXmaComposite, xmaComposite));
			}
		}
		return xmaComposite;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public XMAComposite basicGetXmaComposite() {
		return xmaComposite;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setXmaComposite(XMAComposite newXmaComposite) {
		XMAComposite oldXmaComposite = xmaComposite;
		xmaComposite = newXmaComposite;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_COMPOSITE__XMA_COMPOSITE, oldXmaComposite, xmaComposite));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<FieldFlag> getFieldFlags() {
		if (fieldFlags == null) {
			fieldFlags = new EObjectContainmentEList<FieldFlag>(FieldFlag.class, this, PomPackage.REFERENCED_XMA_COMPOSITE__FIELD_FLAGS);
		}
		return fieldFlags;
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public TabableFlag getTabableFlag() {
		return tabableFlag;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetTabableFlag(TabableFlag newTabableFlag, NotificationChain msgs) {
		TabableFlag oldTabableFlag = tabableFlag;
		tabableFlag = newTabableFlag;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_COMPOSITE__TABABLE_FLAG, oldTabableFlag, newTabableFlag);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setTabableFlag(TabableFlag newTabableFlag) {
		if (newTabableFlag != tabableFlag) {
			NotificationChain msgs = null;
			if (tabableFlag != null)
				msgs = ((InternalEObject)tabableFlag).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_COMPOSITE__TABABLE_FLAG, null, msgs);
			if (newTabableFlag != null)
				msgs = ((InternalEObject)newTabableFlag).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_COMPOSITE__TABABLE_FLAG, null, msgs);
			msgs = basicSetTabableFlag(newTabableFlag, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_COMPOSITE__TABABLE_FLAG, newTabableFlag, newTabableFlag));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case PomPackage.REFERENCED_XMA_COMPOSITE__CONTENT:
				return basicSetContent(null, msgs);
			case PomPackage.REFERENCED_XMA_COMPOSITE__FIELD_FLAGS:
				return ((InternalEList<?>)getFieldFlags()).basicRemove(otherEnd, msgs);
			case PomPackage.REFERENCED_XMA_COMPOSITE__TABABLE_FLAG:
				return basicSetTabableFlag(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PomPackage.REFERENCED_XMA_COMPOSITE__CONTENT:
				return getContent();
			case PomPackage.REFERENCED_XMA_COMPOSITE__XMA_COMPOSITE:
				if (resolve) return getXmaComposite();
				return basicGetXmaComposite();
			case PomPackage.REFERENCED_XMA_COMPOSITE__FIELD_FLAGS:
				return getFieldFlags();
			case PomPackage.REFERENCED_XMA_COMPOSITE__TABABLE_FLAG:
				return getTabableFlag();
			case PomPackage.REFERENCED_XMA_COMPOSITE__REFERENCING_PAGE_COMPOSITE:
				return isReferencingPageComposite();
			case PomPackage.REFERENCED_XMA_COMPOSITE__HORIZONTAL_PARTITIONING:
				return isHorizontalPartitioning();
			case PomPackage.REFERENCED_XMA_COMPOSITE__VERTICAL_PARTITIONING:
				return isVerticalPartitioning();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PomPackage.REFERENCED_XMA_COMPOSITE__CONTENT:
				setContent((Content)newValue);
				return;
			case PomPackage.REFERENCED_XMA_COMPOSITE__XMA_COMPOSITE:
				setXmaComposite((XMAComposite)newValue);
				return;
			case PomPackage.REFERENCED_XMA_COMPOSITE__FIELD_FLAGS:
				getFieldFlags().clear();
				getFieldFlags().addAll((Collection<? extends FieldFlag>)newValue);
				return;
			case PomPackage.REFERENCED_XMA_COMPOSITE__TABABLE_FLAG:
				setTabableFlag((TabableFlag)newValue);
				return;
			case PomPackage.REFERENCED_XMA_COMPOSITE__REFERENCING_PAGE_COMPOSITE:
				setReferencingPageComposite((Boolean)newValue);
				return;
			case PomPackage.REFERENCED_XMA_COMPOSITE__HORIZONTAL_PARTITIONING:
				setHorizontalPartitioning((Boolean)newValue);
				return;
			case PomPackage.REFERENCED_XMA_COMPOSITE__VERTICAL_PARTITIONING:
				setVerticalPartitioning((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PomPackage.REFERENCED_XMA_COMPOSITE__CONTENT:
				setContent((Content)null);
				return;
			case PomPackage.REFERENCED_XMA_COMPOSITE__XMA_COMPOSITE:
				setXmaComposite((XMAComposite)null);
				return;
			case PomPackage.REFERENCED_XMA_COMPOSITE__FIELD_FLAGS:
				getFieldFlags().clear();
				return;
			case PomPackage.REFERENCED_XMA_COMPOSITE__TABABLE_FLAG:
				setTabableFlag((TabableFlag)null);
				return;
			case PomPackage.REFERENCED_XMA_COMPOSITE__REFERENCING_PAGE_COMPOSITE:
				setReferencingPageComposite(REFERENCING_PAGE_COMPOSITE_EDEFAULT);
				return;
			case PomPackage.REFERENCED_XMA_COMPOSITE__HORIZONTAL_PARTITIONING:
				setHorizontalPartitioning(HORIZONTAL_PARTITIONING_EDEFAULT);
				return;
			case PomPackage.REFERENCED_XMA_COMPOSITE__VERTICAL_PARTITIONING:
				setVerticalPartitioning(VERTICAL_PARTITIONING_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PomPackage.REFERENCED_XMA_COMPOSITE__CONTENT:
				return content != null;
			case PomPackage.REFERENCED_XMA_COMPOSITE__XMA_COMPOSITE:
				return xmaComposite != null;
			case PomPackage.REFERENCED_XMA_COMPOSITE__FIELD_FLAGS:
				return fieldFlags != null && !fieldFlags.isEmpty();
			case PomPackage.REFERENCED_XMA_COMPOSITE__TABABLE_FLAG:
				return tabableFlag != null;
			case PomPackage.REFERENCED_XMA_COMPOSITE__REFERENCING_PAGE_COMPOSITE:
				return referencingPageComposite != REFERENCING_PAGE_COMPOSITE_EDEFAULT;
			case PomPackage.REFERENCED_XMA_COMPOSITE__HORIZONTAL_PARTITIONING:
				return horizontalPartitioning != HORIZONTAL_PARTITIONING_EDEFAULT;
			case PomPackage.REFERENCED_XMA_COMPOSITE__VERTICAL_PARTITIONING:
				return verticalPartitioning != VERTICAL_PARTITIONING_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == GuiElement.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == Composite.class) {
			switch (derivedFeatureID) {
				case PomPackage.REFERENCED_XMA_COMPOSITE__CONTENT: return PomPackage.COMPOSITE__CONTENT;
				default: return -1;
			}
		}
		if (baseClass == IElementOnWhichCanBeAttached.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ComposedElement.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ComplexElement.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IComposite.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == GuiElement.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == Composite.class) {
			switch (baseFeatureID) {
				case PomPackage.COMPOSITE__CONTENT: return PomPackage.REFERENCED_XMA_COMPOSITE__CONTENT;
				default: return -1;
			}
		}
		if (baseClass == IElementOnWhichCanBeAttached.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ComposedElement.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ComplexElement.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IComposite.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (referencingPageComposite: ");
		result.append(referencingPageComposite);
		result.append(", horizontalPartitioning: ");
		result.append(horizontalPartitioning);
		result.append(", verticalPartitioning: ");
		result.append(verticalPartitioning);
		result.append(')');
		return result.toString();
	}

} //ReferencedXMACompositeImpl
