/**
 * <copyright>
 * </copyright>
 *
 * $Id: ReferencedXMAPageImpl.java 8635 2011-11-03 21:04:39Z hoenninger $
 */
package org.openxma.dsl.pom.model.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.openxma.dsl.core.CorePackage;
import org.openxma.dsl.core.model.IDocumentable;
import org.openxma.dsl.core.model.ReferenceableByXmadslVariable;
import org.openxma.dsl.dom.model.ConditionsBlock;
import org.openxma.dsl.dom.model.Dependant;
import org.openxma.dsl.pom.PomPackage;
import org.openxma.dsl.pom.model.Command;
import org.openxma.dsl.pom.model.ComposeData;
import org.openxma.dsl.pom.model.Composite;
import org.openxma.dsl.pom.model.Content;
import org.openxma.dsl.pom.model.DataMappingList;
import org.openxma.dsl.pom.model.DataObjectVariable;
import org.openxma.dsl.pom.model.Definitions;
import org.openxma.dsl.pom.model.EventMappingList;
import org.openxma.dsl.pom.model.FieldFlag;
import org.openxma.dsl.pom.model.GrayLogic;
import org.openxma.dsl.pom.model.GuiElement;
import org.openxma.dsl.pom.model.Invokeable;
import org.openxma.dsl.pom.model.LogicBlock;
import org.openxma.dsl.pom.model.Page;
import org.openxma.dsl.pom.model.PageDefinition;
import org.openxma.dsl.pom.model.ReferencedXMAPage;

import at.spardat.xma.guidesign.XMAPage;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Referenced XMA Page</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMAPageImpl#getContent <em>Content</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMAPageImpl#getTxtDescription <em>Txt Description</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMAPageImpl#getComposeLayout <em>Compose Layout</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMAPageImpl#getDataobjects <em>Dataobjects</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMAPageImpl#getDataMapping <em>Data Mapping</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMAPageImpl#getCommands <em>Commands</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMAPageImpl#getEvents <em>Events</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMAPageImpl#getConditionsBlock <em>Conditions Block</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMAPageImpl#getDefinitions <em>Definitions</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMAPageImpl#getXmaPage <em>Xma Page</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMAPageImpl#getFieldFlags <em>Field Flags</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMAPageImpl#getDependencies <em>Dependencies</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMAPageImpl#getLogicBlock <em>Logic Block</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ReferencedXMAPageImpl#getGrayLogic <em>Gray Logic</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ReferencedXMAPageImpl extends ReferencedXMAGuiElementImpl implements ReferencedXMAPage {
	/**
	 * The cached value of the '{@link #getContent() <em>Content</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContent()
	 * @generated
	 * @ordered
	 */
	protected Content content;

	/**
	 * The default value of the '{@link #getTxtDescription() <em>Txt Description</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getTxtDescription()
	 * @generated
	 * @ordered
	 */
    protected static final String TXT_DESCRIPTION_EDEFAULT = null;

    /**
	 * The cached value of the '{@link #getTxtDescription() <em>Txt Description</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getTxtDescription()
	 * @generated
	 * @ordered
	 */
    protected String txtDescription = TXT_DESCRIPTION_EDEFAULT;

    /**
	 * The cached value of the '{@link #getComposeLayout() <em>Compose Layout</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComposeLayout()
	 * @generated
	 * @ordered
	 */
	protected ComposeData composeLayout;

	/**
	 * The cached value of the '{@link #getDataobjects() <em>Dataobjects</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDataobjects()
	 * @generated
	 * @ordered
	 */
	protected EList<DataObjectVariable> dataobjects;

	/**
	 * The cached value of the '{@link #getDataMapping() <em>Data Mapping</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDataMapping()
	 * @generated
	 * @ordered
	 */
	protected DataMappingList dataMapping;

	/**
	 * The cached value of the '{@link #getCommands() <em>Commands</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCommands()
	 * @generated
	 * @ordered
	 */
	protected EList<Command> commands;

	/**
	 * The cached value of the '{@link #getEvents() <em>Events</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEvents()
	 * @generated
	 * @ordered
	 */
	protected EventMappingList events;

	/**
	 * The cached value of the '{@link #getConditionsBlock() <em>Conditions Block</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConditionsBlock()
	 * @generated
	 * @ordered
	 */
	protected ConditionsBlock conditionsBlock;

	/**
	 * The cached value of the '{@link #getDefinitions() <em>Definitions</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDefinitions()
	 * @generated
	 * @ordered
	 */
	protected Definitions definitions;

	/**
	 * The cached value of the '{@link #getXmaPage() <em>Xma Page</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getXmaPage()
	 * @generated
	 * @ordered
	 */
	protected XMAPage xmaPage;

	/**
	 * The cached value of the '{@link #getFieldFlags() <em>Field Flags</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFieldFlags()
	 * @generated
	 * @ordered
	 */
	protected EList<FieldFlag> fieldFlags;

	/**
	 * The cached value of the '{@link #getDependencies() <em>Dependencies</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDependencies()
	 * @generated
	 * @ordered
	 */
	protected EList<Dependant> dependencies;

	/**
	 * The cached value of the '{@link #getLogicBlock() <em>Logic Block</em>}' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getLogicBlock()
	 * @generated
	 * @ordered
	 */
    protected LogicBlock logicBlock;

    /**
	 * The cached value of the '{@link #getGrayLogic() <em>Gray Logic</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGrayLogic()
	 * @generated
	 * @ordered
	 */
	protected GrayLogic grayLogic;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReferencedXMAPageImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PomPackage.Literals.REFERENCED_XMA_PAGE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeData getComposeLayout() {
		return composeLayout;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetComposeLayout(ComposeData newComposeLayout, NotificationChain msgs) {
		ComposeData oldComposeLayout = composeLayout;
		composeLayout = newComposeLayout;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__COMPOSE_LAYOUT, oldComposeLayout, newComposeLayout);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setComposeLayout(ComposeData newComposeLayout) {
		if (newComposeLayout != composeLayout) {
			NotificationChain msgs = null;
			if (composeLayout != null)
				msgs = ((InternalEObject)composeLayout).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_PAGE__COMPOSE_LAYOUT, null, msgs);
			if (newComposeLayout != null)
				msgs = ((InternalEObject)newComposeLayout).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_PAGE__COMPOSE_LAYOUT, null, msgs);
			msgs = basicSetComposeLayout(newComposeLayout, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__COMPOSE_LAYOUT, newComposeLayout, newComposeLayout));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<DataObjectVariable> getDataobjects() {
		if (dataobjects == null) {
			dataobjects = new EObjectContainmentEList<DataObjectVariable>(DataObjectVariable.class, this, PomPackage.REFERENCED_XMA_PAGE__DATAOBJECTS);
		}
		return dataobjects;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataMappingList getDataMapping() {
		return dataMapping;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDataMapping(DataMappingList newDataMapping, NotificationChain msgs) {
		DataMappingList oldDataMapping = dataMapping;
		dataMapping = newDataMapping;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__DATA_MAPPING, oldDataMapping, newDataMapping);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDataMapping(DataMappingList newDataMapping) {
		if (newDataMapping != dataMapping) {
			NotificationChain msgs = null;
			if (dataMapping != null)
				msgs = ((InternalEObject)dataMapping).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_PAGE__DATA_MAPPING, null, msgs);
			if (newDataMapping != null)
				msgs = ((InternalEObject)newDataMapping).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_PAGE__DATA_MAPPING, null, msgs);
			msgs = basicSetDataMapping(newDataMapping, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__DATA_MAPPING, newDataMapping, newDataMapping));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Command> getCommands() {
		if (commands == null) {
			commands = new EObjectContainmentEList<Command>(Command.class, this, PomPackage.REFERENCED_XMA_PAGE__COMMANDS);
		}
		return commands;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventMappingList getEvents() {
		return events;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetEvents(EventMappingList newEvents, NotificationChain msgs) {
		EventMappingList oldEvents = events;
		events = newEvents;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__EVENTS, oldEvents, newEvents);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEvents(EventMappingList newEvents) {
		if (newEvents != events) {
			NotificationChain msgs = null;
			if (events != null)
				msgs = ((InternalEObject)events).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_PAGE__EVENTS, null, msgs);
			if (newEvents != null)
				msgs = ((InternalEObject)newEvents).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_PAGE__EVENTS, null, msgs);
			msgs = basicSetEvents(newEvents, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__EVENTS, newEvents, newEvents));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConditionsBlock getConditionsBlock() {
		return conditionsBlock;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetConditionsBlock(ConditionsBlock newConditionsBlock, NotificationChain msgs) {
		ConditionsBlock oldConditionsBlock = conditionsBlock;
		conditionsBlock = newConditionsBlock;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__CONDITIONS_BLOCK, oldConditionsBlock, newConditionsBlock);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setConditionsBlock(ConditionsBlock newConditionsBlock) {
		if (newConditionsBlock != conditionsBlock) {
			NotificationChain msgs = null;
			if (conditionsBlock != null)
				msgs = ((InternalEObject)conditionsBlock).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_PAGE__CONDITIONS_BLOCK, null, msgs);
			if (newConditionsBlock != null)
				msgs = ((InternalEObject)newConditionsBlock).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_PAGE__CONDITIONS_BLOCK, null, msgs);
			msgs = basicSetConditionsBlock(newConditionsBlock, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__CONDITIONS_BLOCK, newConditionsBlock, newConditionsBlock));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Content getContent() {
		return content;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetContent(Content newContent, NotificationChain msgs) {
		Content oldContent = content;
		content = newContent;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__CONTENT, oldContent, newContent);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setContent(Content newContent) {
		if (newContent != content) {
			NotificationChain msgs = null;
			if (content != null)
				msgs = ((InternalEObject)content).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_PAGE__CONTENT, null, msgs);
			if (newContent != null)
				msgs = ((InternalEObject)newContent).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_PAGE__CONTENT, null, msgs);
			msgs = basicSetContent(newContent, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__CONTENT, newContent, newContent));
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String getTxtDescription() {
		return txtDescription;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setTxtDescription(String newTxtDescription) {
		String oldTxtDescription = txtDescription;
		txtDescription = newTxtDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__TXT_DESCRIPTION, oldTxtDescription, txtDescription));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Definitions getDefinitions() {
		return definitions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDefinitions(Definitions newDefinitions, NotificationChain msgs) {
		Definitions oldDefinitions = definitions;
		definitions = newDefinitions;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__DEFINITIONS, oldDefinitions, newDefinitions);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDefinitions(Definitions newDefinitions) {
		if (newDefinitions != definitions) {
			NotificationChain msgs = null;
			if (definitions != null)
				msgs = ((InternalEObject)definitions).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_PAGE__DEFINITIONS, null, msgs);
			if (newDefinitions != null)
				msgs = ((InternalEObject)newDefinitions).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_PAGE__DEFINITIONS, null, msgs);
			msgs = basicSetDefinitions(newDefinitions, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__DEFINITIONS, newDefinitions, newDefinitions));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public XMAPage getXmaPage() {
		if (xmaPage != null && xmaPage.eIsProxy()) {
			InternalEObject oldXmaPage = (InternalEObject)xmaPage;
			xmaPage = (XMAPage)eResolveProxy(oldXmaPage);
			if (xmaPage != oldXmaPage) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, PomPackage.REFERENCED_XMA_PAGE__XMA_PAGE, oldXmaPage, xmaPage));
			}
		}
		return xmaPage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public XMAPage basicGetXmaPage() {
		return xmaPage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setXmaPage(XMAPage newXmaPage) {
		XMAPage oldXmaPage = xmaPage;
		xmaPage = newXmaPage;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__XMA_PAGE, oldXmaPage, xmaPage));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<FieldFlag> getFieldFlags() {
		if (fieldFlags == null) {
			fieldFlags = new EObjectContainmentEList<FieldFlag>(FieldFlag.class, this, PomPackage.REFERENCED_XMA_PAGE__FIELD_FLAGS);
		}
		return fieldFlags;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Dependant> getDependencies() {
		if (dependencies == null) {
			dependencies = new EObjectResolvingEList<Dependant>(Dependant.class, this, PomPackage.REFERENCED_XMA_PAGE__DEPENDENCIES);
		}
		return dependencies;
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public LogicBlock getLogicBlock() {
		return logicBlock;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetLogicBlock(LogicBlock newLogicBlock, NotificationChain msgs) {
		LogicBlock oldLogicBlock = logicBlock;
		logicBlock = newLogicBlock;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__LOGIC_BLOCK, oldLogicBlock, newLogicBlock);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setLogicBlock(LogicBlock newLogicBlock) {
		if (newLogicBlock != logicBlock) {
			NotificationChain msgs = null;
			if (logicBlock != null)
				msgs = ((InternalEObject)logicBlock).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_PAGE__LOGIC_BLOCK, null, msgs);
			if (newLogicBlock != null)
				msgs = ((InternalEObject)newLogicBlock).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_PAGE__LOGIC_BLOCK, null, msgs);
			msgs = basicSetLogicBlock(newLogicBlock, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__LOGIC_BLOCK, newLogicBlock, newLogicBlock));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GrayLogic getGrayLogic() {
		return grayLogic;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetGrayLogic(GrayLogic newGrayLogic, NotificationChain msgs) {
		GrayLogic oldGrayLogic = grayLogic;
		grayLogic = newGrayLogic;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__GRAY_LOGIC, oldGrayLogic, newGrayLogic);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGrayLogic(GrayLogic newGrayLogic) {
		if (newGrayLogic != grayLogic) {
			NotificationChain msgs = null;
			if (grayLogic != null)
				msgs = ((InternalEObject)grayLogic).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_PAGE__GRAY_LOGIC, null, msgs);
			if (newGrayLogic != null)
				msgs = ((InternalEObject)newGrayLogic).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.REFERENCED_XMA_PAGE__GRAY_LOGIC, null, msgs);
			msgs = basicSetGrayLogic(newGrayLogic, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.REFERENCED_XMA_PAGE__GRAY_LOGIC, newGrayLogic, newGrayLogic));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case PomPackage.REFERENCED_XMA_PAGE__CONTENT:
				return basicSetContent(null, msgs);
			case PomPackage.REFERENCED_XMA_PAGE__COMPOSE_LAYOUT:
				return basicSetComposeLayout(null, msgs);
			case PomPackage.REFERENCED_XMA_PAGE__DATAOBJECTS:
				return ((InternalEList<?>)getDataobjects()).basicRemove(otherEnd, msgs);
			case PomPackage.REFERENCED_XMA_PAGE__DATA_MAPPING:
				return basicSetDataMapping(null, msgs);
			case PomPackage.REFERENCED_XMA_PAGE__COMMANDS:
				return ((InternalEList<?>)getCommands()).basicRemove(otherEnd, msgs);
			case PomPackage.REFERENCED_XMA_PAGE__EVENTS:
				return basicSetEvents(null, msgs);
			case PomPackage.REFERENCED_XMA_PAGE__CONDITIONS_BLOCK:
				return basicSetConditionsBlock(null, msgs);
			case PomPackage.REFERENCED_XMA_PAGE__DEFINITIONS:
				return basicSetDefinitions(null, msgs);
			case PomPackage.REFERENCED_XMA_PAGE__FIELD_FLAGS:
				return ((InternalEList<?>)getFieldFlags()).basicRemove(otherEnd, msgs);
			case PomPackage.REFERENCED_XMA_PAGE__LOGIC_BLOCK:
				return basicSetLogicBlock(null, msgs);
			case PomPackage.REFERENCED_XMA_PAGE__GRAY_LOGIC:
				return basicSetGrayLogic(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PomPackage.REFERENCED_XMA_PAGE__CONTENT:
				return getContent();
			case PomPackage.REFERENCED_XMA_PAGE__TXT_DESCRIPTION:
				return getTxtDescription();
			case PomPackage.REFERENCED_XMA_PAGE__COMPOSE_LAYOUT:
				return getComposeLayout();
			case PomPackage.REFERENCED_XMA_PAGE__DATAOBJECTS:
				return getDataobjects();
			case PomPackage.REFERENCED_XMA_PAGE__DATA_MAPPING:
				return getDataMapping();
			case PomPackage.REFERENCED_XMA_PAGE__COMMANDS:
				return getCommands();
			case PomPackage.REFERENCED_XMA_PAGE__EVENTS:
				return getEvents();
			case PomPackage.REFERENCED_XMA_PAGE__CONDITIONS_BLOCK:
				return getConditionsBlock();
			case PomPackage.REFERENCED_XMA_PAGE__DEFINITIONS:
				return getDefinitions();
			case PomPackage.REFERENCED_XMA_PAGE__XMA_PAGE:
				if (resolve) return getXmaPage();
				return basicGetXmaPage();
			case PomPackage.REFERENCED_XMA_PAGE__FIELD_FLAGS:
				return getFieldFlags();
			case PomPackage.REFERENCED_XMA_PAGE__DEPENDENCIES:
				return getDependencies();
			case PomPackage.REFERENCED_XMA_PAGE__LOGIC_BLOCK:
				return getLogicBlock();
			case PomPackage.REFERENCED_XMA_PAGE__GRAY_LOGIC:
				return getGrayLogic();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PomPackage.REFERENCED_XMA_PAGE__CONTENT:
				setContent((Content)newValue);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__TXT_DESCRIPTION:
				setTxtDescription((String)newValue);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__COMPOSE_LAYOUT:
				setComposeLayout((ComposeData)newValue);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__DATAOBJECTS:
				getDataobjects().clear();
				getDataobjects().addAll((Collection<? extends DataObjectVariable>)newValue);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__DATA_MAPPING:
				setDataMapping((DataMappingList)newValue);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__COMMANDS:
				getCommands().clear();
				getCommands().addAll((Collection<? extends Command>)newValue);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__EVENTS:
				setEvents((EventMappingList)newValue);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__CONDITIONS_BLOCK:
				setConditionsBlock((ConditionsBlock)newValue);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__DEFINITIONS:
				setDefinitions((Definitions)newValue);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__XMA_PAGE:
				setXmaPage((XMAPage)newValue);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__FIELD_FLAGS:
				getFieldFlags().clear();
				getFieldFlags().addAll((Collection<? extends FieldFlag>)newValue);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__DEPENDENCIES:
				getDependencies().clear();
				getDependencies().addAll((Collection<? extends Dependant>)newValue);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__LOGIC_BLOCK:
				setLogicBlock((LogicBlock)newValue);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__GRAY_LOGIC:
				setGrayLogic((GrayLogic)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PomPackage.REFERENCED_XMA_PAGE__CONTENT:
				setContent((Content)null);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__TXT_DESCRIPTION:
				setTxtDescription(TXT_DESCRIPTION_EDEFAULT);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__COMPOSE_LAYOUT:
				setComposeLayout((ComposeData)null);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__DATAOBJECTS:
				getDataobjects().clear();
				return;
			case PomPackage.REFERENCED_XMA_PAGE__DATA_MAPPING:
				setDataMapping((DataMappingList)null);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__COMMANDS:
				getCommands().clear();
				return;
			case PomPackage.REFERENCED_XMA_PAGE__EVENTS:
				setEvents((EventMappingList)null);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__CONDITIONS_BLOCK:
				setConditionsBlock((ConditionsBlock)null);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__DEFINITIONS:
				setDefinitions((Definitions)null);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__XMA_PAGE:
				setXmaPage((XMAPage)null);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__FIELD_FLAGS:
				getFieldFlags().clear();
				return;
			case PomPackage.REFERENCED_XMA_PAGE__DEPENDENCIES:
				getDependencies().clear();
				return;
			case PomPackage.REFERENCED_XMA_PAGE__LOGIC_BLOCK:
				setLogicBlock((LogicBlock)null);
				return;
			case PomPackage.REFERENCED_XMA_PAGE__GRAY_LOGIC:
				setGrayLogic((GrayLogic)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PomPackage.REFERENCED_XMA_PAGE__CONTENT:
				return content != null;
			case PomPackage.REFERENCED_XMA_PAGE__TXT_DESCRIPTION:
				return TXT_DESCRIPTION_EDEFAULT == null ? txtDescription != null : !TXT_DESCRIPTION_EDEFAULT.equals(txtDescription);
			case PomPackage.REFERENCED_XMA_PAGE__COMPOSE_LAYOUT:
				return composeLayout != null;
			case PomPackage.REFERENCED_XMA_PAGE__DATAOBJECTS:
				return dataobjects != null && !dataobjects.isEmpty();
			case PomPackage.REFERENCED_XMA_PAGE__DATA_MAPPING:
				return dataMapping != null;
			case PomPackage.REFERENCED_XMA_PAGE__COMMANDS:
				return commands != null && !commands.isEmpty();
			case PomPackage.REFERENCED_XMA_PAGE__EVENTS:
				return events != null;
			case PomPackage.REFERENCED_XMA_PAGE__CONDITIONS_BLOCK:
				return conditionsBlock != null;
			case PomPackage.REFERENCED_XMA_PAGE__DEFINITIONS:
				return definitions != null;
			case PomPackage.REFERENCED_XMA_PAGE__XMA_PAGE:
				return xmaPage != null;
			case PomPackage.REFERENCED_XMA_PAGE__FIELD_FLAGS:
				return fieldFlags != null && !fieldFlags.isEmpty();
			case PomPackage.REFERENCED_XMA_PAGE__DEPENDENCIES:
				return dependencies != null && !dependencies.isEmpty();
			case PomPackage.REFERENCED_XMA_PAGE__LOGIC_BLOCK:
				return logicBlock != null;
			case PomPackage.REFERENCED_XMA_PAGE__GRAY_LOGIC:
				return grayLogic != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == ReferenceableByXmadslVariable.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == PageDefinition.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == GuiElement.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == Composite.class) {
			switch (derivedFeatureID) {
				case PomPackage.REFERENCED_XMA_PAGE__CONTENT: return PomPackage.COMPOSITE__CONTENT;
				default: return -1;
			}
		}
		if (baseClass == Invokeable.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IDocumentable.class) {
			switch (derivedFeatureID) {
				case PomPackage.REFERENCED_XMA_PAGE__TXT_DESCRIPTION: return CorePackage.IDOCUMENTABLE__TXT_DESCRIPTION;
				default: return -1;
			}
		}
		if (baseClass == Page.class) {
			switch (derivedFeatureID) {
				case PomPackage.REFERENCED_XMA_PAGE__COMPOSE_LAYOUT: return PomPackage.PAGE__COMPOSE_LAYOUT;
				case PomPackage.REFERENCED_XMA_PAGE__DATAOBJECTS: return PomPackage.PAGE__DATAOBJECTS;
				case PomPackage.REFERENCED_XMA_PAGE__DATA_MAPPING: return PomPackage.PAGE__DATA_MAPPING;
				case PomPackage.REFERENCED_XMA_PAGE__COMMANDS: return PomPackage.PAGE__COMMANDS;
				case PomPackage.REFERENCED_XMA_PAGE__EVENTS: return PomPackage.PAGE__EVENTS;
				case PomPackage.REFERENCED_XMA_PAGE__CONDITIONS_BLOCK: return PomPackage.PAGE__CONDITIONS_BLOCK;
				case PomPackage.REFERENCED_XMA_PAGE__DEFINITIONS: return PomPackage.PAGE__DEFINITIONS;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == ReferenceableByXmadslVariable.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == PageDefinition.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == GuiElement.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == Composite.class) {
			switch (baseFeatureID) {
				case PomPackage.COMPOSITE__CONTENT: return PomPackage.REFERENCED_XMA_PAGE__CONTENT;
				default: return -1;
			}
		}
		if (baseClass == Invokeable.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IDocumentable.class) {
			switch (baseFeatureID) {
				case CorePackage.IDOCUMENTABLE__TXT_DESCRIPTION: return PomPackage.REFERENCED_XMA_PAGE__TXT_DESCRIPTION;
				default: return -1;
			}
		}
		if (baseClass == Page.class) {
			switch (baseFeatureID) {
				case PomPackage.PAGE__COMPOSE_LAYOUT: return PomPackage.REFERENCED_XMA_PAGE__COMPOSE_LAYOUT;
				case PomPackage.PAGE__DATAOBJECTS: return PomPackage.REFERENCED_XMA_PAGE__DATAOBJECTS;
				case PomPackage.PAGE__DATA_MAPPING: return PomPackage.REFERENCED_XMA_PAGE__DATA_MAPPING;
				case PomPackage.PAGE__COMMANDS: return PomPackage.REFERENCED_XMA_PAGE__COMMANDS;
				case PomPackage.PAGE__EVENTS: return PomPackage.REFERENCED_XMA_PAGE__EVENTS;
				case PomPackage.PAGE__CONDITIONS_BLOCK: return PomPackage.REFERENCED_XMA_PAGE__CONDITIONS_BLOCK;
				case PomPackage.PAGE__DEFINITIONS: return PomPackage.REFERENCED_XMA_PAGE__DEFINITIONS;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (txtDescription: ");
		result.append(txtDescription);
		result.append(')');
		return result.toString();
	}

} //ReferencedXMAPageImpl
