/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.openxma.dsl.pom.model.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.openxma.dsl.core.model.BoolLiteral;
import org.openxma.dsl.core.model.impl.ReferenceableByXmadslVariableImpl;
import org.openxma.dsl.dom.model.PresentableFeature;
import org.openxma.dsl.pom.PomPackage;
import org.openxma.dsl.pom.model.ComplexElement;
import org.openxma.dsl.pom.model.ComposedElement;
import org.openxma.dsl.pom.model.DataObjectVariable;
import org.openxma.dsl.pom.model.FieldFlag;
import org.openxma.dsl.pom.model.GuiElement;
import org.openxma.dsl.pom.model.IDummy;
import org.openxma.dsl.pom.model.IElementOnWhichCanBeAttached;
import org.openxma.dsl.pom.model.IElementWithLayoutData;
import org.openxma.dsl.pom.model.IGuiElementWithEvent;
import org.openxma.dsl.pom.model.IReferenceableByStatementVariable;
import org.openxma.dsl.pom.model.LayoutDataProperty;
import org.openxma.dsl.pom.model.TabableFlag;
import org.openxma.dsl.pom.model.Table;
import org.openxma.dsl.pom.model.TableColumn;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Table</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableImpl#getLayoutProperties <em>Layout Properties</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableImpl#getFieldFlags <em>Field Flags</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableImpl#getTabableFlag <em>Tabable Flag</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableImpl#getObject <em>Object</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableImpl#getKey <em>Key</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableImpl#getColumnMinWidth <em>Column Min Width</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableImpl#getMultiSelection <em>Multi Selection</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableImpl#getOneway <em>Oneway</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableImpl#getGridvisible <em>Gridvisible</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableImpl#getSortindicator <em>Sortindicator</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableImpl#getPageable <em>Pageable</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableImpl#getFilterable <em>Filterable</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableImpl#getCheckSelection <em>Check Selection</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableImpl#getColumns <em>Columns</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TableImpl extends ReferenceableByXmadslVariableImpl implements Table {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getLayoutProperties() <em>Layout Properties</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLayoutProperties()
	 * @generated
	 * @ordered
	 */
	protected EList<LayoutDataProperty> layoutProperties;

	/**
	 * The cached value of the '{@link #getFieldFlags() <em>Field Flags</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFieldFlags()
	 * @generated
	 * @ordered
	 */
	protected EList<FieldFlag> fieldFlags;

	/**
	 * The cached value of the '{@link #getTabableFlag() <em>Tabable Flag</em>}' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getTabableFlag()
	 * @generated
	 * @ordered
	 */
    protected TabableFlag tabableFlag;

    /**
	 * The cached value of the '{@link #getObject() <em>Object</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObject()
	 * @generated
	 * @ordered
	 */
	protected DataObjectVariable object;

	/**
	 * The cached value of the '{@link #getKey() <em>Key</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getKey()
	 * @generated
	 * @ordered
	 */
	protected PresentableFeature key;

	/**
	 * The default value of the '{@link #getColumnMinWidth() <em>Column Min Width</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getColumnMinWidth()
	 * @generated
	 * @ordered
	 */
	protected static final int COLUMN_MIN_WIDTH_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getColumnMinWidth() <em>Column Min Width</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getColumnMinWidth()
	 * @generated
	 * @ordered
	 */
	protected int columnMinWidth = COLUMN_MIN_WIDTH_EDEFAULT;

	/**
	 * The cached value of the '{@link #getMultiSelection() <em>Multi Selection</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMultiSelection()
	 * @generated
	 * @ordered
	 */
	protected BoolLiteral multiSelection;

	/**
	 * The cached value of the '{@link #getOneway() <em>Oneway</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOneway()
	 * @generated
	 * @ordered
	 */
	protected BoolLiteral oneway;

	/**
	 * The cached value of the '{@link #getGridvisible() <em>Gridvisible</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGridvisible()
	 * @generated
	 * @ordered
	 */
	protected BoolLiteral gridvisible;

	/**
	 * The cached value of the '{@link #getSortindicator() <em>Sortindicator</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSortindicator()
	 * @generated
	 * @ordered
	 */
	protected BoolLiteral sortindicator;

	/**
	 * The cached value of the '{@link #getPageable() <em>Pageable</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPageable()
	 * @generated
	 * @ordered
	 */
	protected BoolLiteral pageable;

	/**
	 * The cached value of the '{@link #getFilterable() <em>Filterable</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFilterable()
	 * @generated
	 * @ordered
	 */
	protected BoolLiteral filterable;

	/**
	 * The cached value of the '{@link #getCheckSelection() <em>Check Selection</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCheckSelection()
	 * @generated
	 * @ordered
	 */
	protected BoolLiteral checkSelection;

	/**
	 * The cached value of the '{@link #getColumns() <em>Columns</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getColumns()
	 * @generated
	 * @ordered
	 */
	protected EList<TableColumn> columns;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TableImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PomPackage.Literals.TABLE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataObjectVariable getObject() {
		if (object != null && object.eIsProxy()) {
			InternalEObject oldObject = (InternalEObject)object;
			object = (DataObjectVariable)eResolveProxy(oldObject);
			if (object != oldObject) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, PomPackage.TABLE__OBJECT, oldObject, object));
			}
		}
		return object;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataObjectVariable basicGetObject() {
		return object;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setObject(DataObjectVariable newObject) {
		DataObjectVariable oldObject = object;
		object = newObject;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__OBJECT, oldObject, object));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PresentableFeature getKey() {
		if (key != null && key.eIsProxy()) {
			InternalEObject oldKey = (InternalEObject)key;
			key = (PresentableFeature)eResolveProxy(oldKey);
			if (key != oldKey) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, PomPackage.TABLE__KEY, oldKey, key));
			}
		}
		return key;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PresentableFeature basicGetKey() {
		return key;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setKey(PresentableFeature newKey) {
		PresentableFeature oldKey = key;
		key = newKey;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__KEY, oldKey, key));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<LayoutDataProperty> getLayoutProperties() {
		if (layoutProperties == null) {
			layoutProperties = new EObjectContainmentEList<LayoutDataProperty>(LayoutDataProperty.class, this, PomPackage.TABLE__LAYOUT_PROPERTIES);
		}
		return layoutProperties;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getColumnMinWidth() {
		return columnMinWidth;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setColumnMinWidth(int newColumnMinWidth) {
		int oldColumnMinWidth = columnMinWidth;
		columnMinWidth = newColumnMinWidth;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__COLUMN_MIN_WIDTH, oldColumnMinWidth, columnMinWidth));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BoolLiteral getMultiSelection() {
		return multiSelection;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetMultiSelection(BoolLiteral newMultiSelection, NotificationChain msgs) {
		BoolLiteral oldMultiSelection = multiSelection;
		multiSelection = newMultiSelection;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__MULTI_SELECTION, oldMultiSelection, newMultiSelection);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMultiSelection(BoolLiteral newMultiSelection) {
		if (newMultiSelection != multiSelection) {
			NotificationChain msgs = null;
			if (multiSelection != null)
				msgs = ((InternalEObject)multiSelection).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE__MULTI_SELECTION, null, msgs);
			if (newMultiSelection != null)
				msgs = ((InternalEObject)newMultiSelection).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE__MULTI_SELECTION, null, msgs);
			msgs = basicSetMultiSelection(newMultiSelection, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__MULTI_SELECTION, newMultiSelection, newMultiSelection));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BoolLiteral getOneway() {
		return oneway;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetOneway(BoolLiteral newOneway, NotificationChain msgs) {
		BoolLiteral oldOneway = oneway;
		oneway = newOneway;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__ONEWAY, oldOneway, newOneway);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOneway(BoolLiteral newOneway) {
		if (newOneway != oneway) {
			NotificationChain msgs = null;
			if (oneway != null)
				msgs = ((InternalEObject)oneway).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE__ONEWAY, null, msgs);
			if (newOneway != null)
				msgs = ((InternalEObject)newOneway).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE__ONEWAY, null, msgs);
			msgs = basicSetOneway(newOneway, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__ONEWAY, newOneway, newOneway));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BoolLiteral getGridvisible() {
		return gridvisible;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetGridvisible(BoolLiteral newGridvisible, NotificationChain msgs) {
		BoolLiteral oldGridvisible = gridvisible;
		gridvisible = newGridvisible;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__GRIDVISIBLE, oldGridvisible, newGridvisible);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGridvisible(BoolLiteral newGridvisible) {
		if (newGridvisible != gridvisible) {
			NotificationChain msgs = null;
			if (gridvisible != null)
				msgs = ((InternalEObject)gridvisible).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE__GRIDVISIBLE, null, msgs);
			if (newGridvisible != null)
				msgs = ((InternalEObject)newGridvisible).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE__GRIDVISIBLE, null, msgs);
			msgs = basicSetGridvisible(newGridvisible, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__GRIDVISIBLE, newGridvisible, newGridvisible));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BoolLiteral getSortindicator() {
		return sortindicator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSortindicator(BoolLiteral newSortindicator, NotificationChain msgs) {
		BoolLiteral oldSortindicator = sortindicator;
		sortindicator = newSortindicator;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__SORTINDICATOR, oldSortindicator, newSortindicator);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSortindicator(BoolLiteral newSortindicator) {
		if (newSortindicator != sortindicator) {
			NotificationChain msgs = null;
			if (sortindicator != null)
				msgs = ((InternalEObject)sortindicator).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE__SORTINDICATOR, null, msgs);
			if (newSortindicator != null)
				msgs = ((InternalEObject)newSortindicator).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE__SORTINDICATOR, null, msgs);
			msgs = basicSetSortindicator(newSortindicator, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__SORTINDICATOR, newSortindicator, newSortindicator));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BoolLiteral getPageable() {
		return pageable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPageable(BoolLiteral newPageable, NotificationChain msgs) {
		BoolLiteral oldPageable = pageable;
		pageable = newPageable;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__PAGEABLE, oldPageable, newPageable);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPageable(BoolLiteral newPageable) {
		if (newPageable != pageable) {
			NotificationChain msgs = null;
			if (pageable != null)
				msgs = ((InternalEObject)pageable).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE__PAGEABLE, null, msgs);
			if (newPageable != null)
				msgs = ((InternalEObject)newPageable).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE__PAGEABLE, null, msgs);
			msgs = basicSetPageable(newPageable, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__PAGEABLE, newPageable, newPageable));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BoolLiteral getFilterable() {
		return filterable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetFilterable(BoolLiteral newFilterable, NotificationChain msgs) {
		BoolLiteral oldFilterable = filterable;
		filterable = newFilterable;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__FILTERABLE, oldFilterable, newFilterable);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFilterable(BoolLiteral newFilterable) {
		if (newFilterable != filterable) {
			NotificationChain msgs = null;
			if (filterable != null)
				msgs = ((InternalEObject)filterable).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE__FILTERABLE, null, msgs);
			if (newFilterable != null)
				msgs = ((InternalEObject)newFilterable).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE__FILTERABLE, null, msgs);
			msgs = basicSetFilterable(newFilterable, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__FILTERABLE, newFilterable, newFilterable));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BoolLiteral getCheckSelection() {
		return checkSelection;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCheckSelection(BoolLiteral newCheckSelection, NotificationChain msgs) {
		BoolLiteral oldCheckSelection = checkSelection;
		checkSelection = newCheckSelection;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__CHECK_SELECTION, oldCheckSelection, newCheckSelection);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCheckSelection(BoolLiteral newCheckSelection) {
		if (newCheckSelection != checkSelection) {
			NotificationChain msgs = null;
			if (checkSelection != null)
				msgs = ((InternalEObject)checkSelection).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE__CHECK_SELECTION, null, msgs);
			if (newCheckSelection != null)
				msgs = ((InternalEObject)newCheckSelection).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE__CHECK_SELECTION, null, msgs);
			msgs = basicSetCheckSelection(newCheckSelection, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__CHECK_SELECTION, newCheckSelection, newCheckSelection));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<TableColumn> getColumns() {
		if (columns == null) {
			columns = new EObjectContainmentEList<TableColumn>(TableColumn.class, this, PomPackage.TABLE__COLUMNS);
		}
		return columns;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<FieldFlag> getFieldFlags() {
		if (fieldFlags == null) {
			fieldFlags = new EObjectContainmentEList<FieldFlag>(FieldFlag.class, this, PomPackage.TABLE__FIELD_FLAGS);
		}
		return fieldFlags;
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public TabableFlag getTabableFlag() {
		return tabableFlag;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetTabableFlag(TabableFlag newTabableFlag, NotificationChain msgs) {
		TabableFlag oldTabableFlag = tabableFlag;
		tabableFlag = newTabableFlag;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__TABABLE_FLAG, oldTabableFlag, newTabableFlag);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setTabableFlag(TabableFlag newTabableFlag) {
		if (newTabableFlag != tabableFlag) {
			NotificationChain msgs = null;
			if (tabableFlag != null)
				msgs = ((InternalEObject)tabableFlag).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE__TABABLE_FLAG, null, msgs);
			if (newTabableFlag != null)
				msgs = ((InternalEObject)newTabableFlag).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE__TABABLE_FLAG, null, msgs);
			msgs = basicSetTabableFlag(newTabableFlag, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE__TABABLE_FLAG, newTabableFlag, newTabableFlag));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case PomPackage.TABLE__LAYOUT_PROPERTIES:
				return ((InternalEList<?>)getLayoutProperties()).basicRemove(otherEnd, msgs);
			case PomPackage.TABLE__FIELD_FLAGS:
				return ((InternalEList<?>)getFieldFlags()).basicRemove(otherEnd, msgs);
			case PomPackage.TABLE__TABABLE_FLAG:
				return basicSetTabableFlag(null, msgs);
			case PomPackage.TABLE__MULTI_SELECTION:
				return basicSetMultiSelection(null, msgs);
			case PomPackage.TABLE__ONEWAY:
				return basicSetOneway(null, msgs);
			case PomPackage.TABLE__GRIDVISIBLE:
				return basicSetGridvisible(null, msgs);
			case PomPackage.TABLE__SORTINDICATOR:
				return basicSetSortindicator(null, msgs);
			case PomPackage.TABLE__PAGEABLE:
				return basicSetPageable(null, msgs);
			case PomPackage.TABLE__FILTERABLE:
				return basicSetFilterable(null, msgs);
			case PomPackage.TABLE__CHECK_SELECTION:
				return basicSetCheckSelection(null, msgs);
			case PomPackage.TABLE__COLUMNS:
				return ((InternalEList<?>)getColumns()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PomPackage.TABLE__NAME:
				return getName();
			case PomPackage.TABLE__LAYOUT_PROPERTIES:
				return getLayoutProperties();
			case PomPackage.TABLE__FIELD_FLAGS:
				return getFieldFlags();
			case PomPackage.TABLE__TABABLE_FLAG:
				return getTabableFlag();
			case PomPackage.TABLE__OBJECT:
				if (resolve) return getObject();
				return basicGetObject();
			case PomPackage.TABLE__KEY:
				if (resolve) return getKey();
				return basicGetKey();
			case PomPackage.TABLE__COLUMN_MIN_WIDTH:
				return getColumnMinWidth();
			case PomPackage.TABLE__MULTI_SELECTION:
				return getMultiSelection();
			case PomPackage.TABLE__ONEWAY:
				return getOneway();
			case PomPackage.TABLE__GRIDVISIBLE:
				return getGridvisible();
			case PomPackage.TABLE__SORTINDICATOR:
				return getSortindicator();
			case PomPackage.TABLE__PAGEABLE:
				return getPageable();
			case PomPackage.TABLE__FILTERABLE:
				return getFilterable();
			case PomPackage.TABLE__CHECK_SELECTION:
				return getCheckSelection();
			case PomPackage.TABLE__COLUMNS:
				return getColumns();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PomPackage.TABLE__NAME:
				setName((String)newValue);
				return;
			case PomPackage.TABLE__LAYOUT_PROPERTIES:
				getLayoutProperties().clear();
				getLayoutProperties().addAll((Collection<? extends LayoutDataProperty>)newValue);
				return;
			case PomPackage.TABLE__FIELD_FLAGS:
				getFieldFlags().clear();
				getFieldFlags().addAll((Collection<? extends FieldFlag>)newValue);
				return;
			case PomPackage.TABLE__TABABLE_FLAG:
				setTabableFlag((TabableFlag)newValue);
				return;
			case PomPackage.TABLE__OBJECT:
				setObject((DataObjectVariable)newValue);
				return;
			case PomPackage.TABLE__KEY:
				setKey((PresentableFeature)newValue);
				return;
			case PomPackage.TABLE__COLUMN_MIN_WIDTH:
				setColumnMinWidth((Integer)newValue);
				return;
			case PomPackage.TABLE__MULTI_SELECTION:
				setMultiSelection((BoolLiteral)newValue);
				return;
			case PomPackage.TABLE__ONEWAY:
				setOneway((BoolLiteral)newValue);
				return;
			case PomPackage.TABLE__GRIDVISIBLE:
				setGridvisible((BoolLiteral)newValue);
				return;
			case PomPackage.TABLE__SORTINDICATOR:
				setSortindicator((BoolLiteral)newValue);
				return;
			case PomPackage.TABLE__PAGEABLE:
				setPageable((BoolLiteral)newValue);
				return;
			case PomPackage.TABLE__FILTERABLE:
				setFilterable((BoolLiteral)newValue);
				return;
			case PomPackage.TABLE__CHECK_SELECTION:
				setCheckSelection((BoolLiteral)newValue);
				return;
			case PomPackage.TABLE__COLUMNS:
				getColumns().clear();
				getColumns().addAll((Collection<? extends TableColumn>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PomPackage.TABLE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case PomPackage.TABLE__LAYOUT_PROPERTIES:
				getLayoutProperties().clear();
				return;
			case PomPackage.TABLE__FIELD_FLAGS:
				getFieldFlags().clear();
				return;
			case PomPackage.TABLE__TABABLE_FLAG:
				setTabableFlag((TabableFlag)null);
				return;
			case PomPackage.TABLE__OBJECT:
				setObject((DataObjectVariable)null);
				return;
			case PomPackage.TABLE__KEY:
				setKey((PresentableFeature)null);
				return;
			case PomPackage.TABLE__COLUMN_MIN_WIDTH:
				setColumnMinWidth(COLUMN_MIN_WIDTH_EDEFAULT);
				return;
			case PomPackage.TABLE__MULTI_SELECTION:
				setMultiSelection((BoolLiteral)null);
				return;
			case PomPackage.TABLE__ONEWAY:
				setOneway((BoolLiteral)null);
				return;
			case PomPackage.TABLE__GRIDVISIBLE:
				setGridvisible((BoolLiteral)null);
				return;
			case PomPackage.TABLE__SORTINDICATOR:
				setSortindicator((BoolLiteral)null);
				return;
			case PomPackage.TABLE__PAGEABLE:
				setPageable((BoolLiteral)null);
				return;
			case PomPackage.TABLE__FILTERABLE:
				setFilterable((BoolLiteral)null);
				return;
			case PomPackage.TABLE__CHECK_SELECTION:
				setCheckSelection((BoolLiteral)null);
				return;
			case PomPackage.TABLE__COLUMNS:
				getColumns().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PomPackage.TABLE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case PomPackage.TABLE__LAYOUT_PROPERTIES:
				return layoutProperties != null && !layoutProperties.isEmpty();
			case PomPackage.TABLE__FIELD_FLAGS:
				return fieldFlags != null && !fieldFlags.isEmpty();
			case PomPackage.TABLE__TABABLE_FLAG:
				return tabableFlag != null;
			case PomPackage.TABLE__OBJECT:
				return object != null;
			case PomPackage.TABLE__KEY:
				return key != null;
			case PomPackage.TABLE__COLUMN_MIN_WIDTH:
				return columnMinWidth != COLUMN_MIN_WIDTH_EDEFAULT;
			case PomPackage.TABLE__MULTI_SELECTION:
				return multiSelection != null;
			case PomPackage.TABLE__ONEWAY:
				return oneway != null;
			case PomPackage.TABLE__GRIDVISIBLE:
				return gridvisible != null;
			case PomPackage.TABLE__SORTINDICATOR:
				return sortindicator != null;
			case PomPackage.TABLE__PAGEABLE:
				return pageable != null;
			case PomPackage.TABLE__FILTERABLE:
				return filterable != null;
			case PomPackage.TABLE__CHECK_SELECTION:
				return checkSelection != null;
			case PomPackage.TABLE__COLUMNS:
				return columns != null && !columns.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == GuiElement.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IElementOnWhichCanBeAttached.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ComposedElement.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ComplexElement.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IDummy.class) {
			switch (derivedFeatureID) {
				case PomPackage.TABLE__NAME: return PomPackage.IDUMMY__NAME;
				default: return -1;
			}
		}
		if (baseClass == IGuiElementWithEvent.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IElementWithLayoutData.class) {
			switch (derivedFeatureID) {
				case PomPackage.TABLE__LAYOUT_PROPERTIES: return PomPackage.IELEMENT_WITH_LAYOUT_DATA__LAYOUT_PROPERTIES;
				case PomPackage.TABLE__FIELD_FLAGS: return PomPackage.IELEMENT_WITH_LAYOUT_DATA__FIELD_FLAGS;
				case PomPackage.TABLE__TABABLE_FLAG: return PomPackage.IELEMENT_WITH_LAYOUT_DATA__TABABLE_FLAG;
				default: return -1;
			}
		}
		if (baseClass == IReferenceableByStatementVariable.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == GuiElement.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IElementOnWhichCanBeAttached.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ComposedElement.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ComplexElement.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IDummy.class) {
			switch (baseFeatureID) {
				case PomPackage.IDUMMY__NAME: return PomPackage.TABLE__NAME;
				default: return -1;
			}
		}
		if (baseClass == IGuiElementWithEvent.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == IElementWithLayoutData.class) {
			switch (baseFeatureID) {
				case PomPackage.IELEMENT_WITH_LAYOUT_DATA__LAYOUT_PROPERTIES: return PomPackage.TABLE__LAYOUT_PROPERTIES;
				case PomPackage.IELEMENT_WITH_LAYOUT_DATA__FIELD_FLAGS: return PomPackage.TABLE__FIELD_FLAGS;
				case PomPackage.IELEMENT_WITH_LAYOUT_DATA__TABABLE_FLAG: return PomPackage.TABLE__TABABLE_FLAG;
				default: return -1;
			}
		}
		if (baseClass == IReferenceableByStatementVariable.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", columnMinWidth: ");
		result.append(columnMinWidth);
		result.append(')');
		return result.toString();
	}
	
//	 /**
//     * @modified
//     * @return the attribute
//     */
//    public Attribute getKeyAsAttribute() {
//    	PresentableFeature key = getKey();
//    	if (key != null) {
//    		return key.getAttribute();
//    	}
//    	return null;
//    }

} //TableImpl
